import { TypedEmitter } from 'tiny-typed-emitter';
import dnsLookup from './functions/dnsLookup';
import { Certificate, ProxyHost } from './type';
interface NginxProxyManagerEvent {
    ready: () => any;
}
declare type Config = {
    host: string;
    username: string;
    password: string;
};
export default class NginxProxyManager extends TypedEmitter<NginxProxyManagerEvent> {
    private _cfg;
    private _api;
    private _token;
    private _tokenExpired;
    isReady: boolean;
    constructor(_cfg: Config);
    private tokenHeader;
    private getToken;
    getProxyHosts(): Promise<ProxyHost[]>;
    createProxyHosts(data: ProxyHost): Promise<ProxyHost>;
    deleteProxyHost(id: number): Promise<import("axios").AxiosResponse<any, any>>;
    getCertificates(): Promise<Certificate[]>;
    validateCertificates(params: {
        certificate: string;
        certificate_key: string;
        intermediate_certificate: string;
    }): Promise<any>;
    deleteCertificate(id: number): Promise<import("axios").AxiosResponse<any, any>>;
    createCustomCertificates(params: {
        name: string;
        certificate: string;
        certificate_key: string;
        intermediate_certificate: string;
    }): Promise<Certificate>;
    uploadCertificates(params: {
        id: number;
        certificate: string;
        certificate_key: string;
        intermediate_certificate: string;
    }): Promise<any>;
}
export declare const DNSLookup: typeof dnsLookup;
export {};
